state STAND
{
	legs
	{
		ready : default
	}

	states
	{
		CHESS_PUZZLE	: CHESSPUZZLE
		SLIDING		: ENV_SLIDING
		THERMAL		: ENV_THERMAL

		RUN_JUMP_FALL	: FALLING !ALTITUDE "31"
		SWIM_IDLE		: IN_WATER "1"

		RUN_FORWARD		: FORWARD ONGROUND RUN
		RUN_BACKWARD	: BACKWARD ONGROUND RUN

		WALK_FORWARD	: FORWARD ONGROUND !CAN_FALL
		WALK_BACKWARD	: BACKWARD ONGROUND

		RUN_FORWARD		: STRAFE_LEFT RUN ONGROUND
		RUN_FORWARD		: STRAFE_RIGHT RUN ONGROUND

		WALK_FORWARD	: STRAFE_LEFT ONGROUND !CAN_FALL
		WALK_FORWARD	: STRAFE_RIGHT ONGROUND !CAN_FALL

		START_JUMP		: ONGROUND +JUMP

		STAND_2IDLE		: STATETIME_LEGS "25" !ATTACKRIGHT !ATTACK_ALTERNATE

		STAND_RESET		: +HAS_WEAPON
		STAND_RESET		: -HAS_WEAPON
		STAND_RESET		: +USE
		STAND_RESET		: -USE
		STAND_RESET		: -ATTACKRIGHT
		STAND_RESET		: -ATTACK_ALTERNATE
	}
}

state CHESS_PUZZLE
{
	legs
	{
		idle_base_01 : default
	}

	states
	{
		STAND	: !CHESSPUZZLE

		CHESS_MOVE		: FORWARD ONGROUND
		CHESS_MOVE		: BACKWARD ONGROUND

		CHESS_MOVE		: STRAFE_LEFT ONGROUND
		CHESS_MOVE		: STRAFE_RIGHT ONGROUND
	}
}

state CHESS_MOVE
{
	legs
	{
		run_nowep : default
	}

	states
	{
		STAND			: !CHESSPUZZLE
		RUN_JUMP_FALL	: FALLING !ALTITUDE "31"
		CHESS_PUZZLE	: !FORWARD !BACKWARD !STRAFE_LEFT !STRAFE_RIGHT
	}
}

state STAND_RESET
{
	states
	{
		STAND : default
	}
}

state STAND_2IDLE
{
	legs
	{
		ready_2_base01 : default
	}

	states
	{
		STAND		: FORWARD 
		STAND		: BACKWARD 
		STAND		: STRAFE_LEFT 
		STAND		: STRAFE_RIGHT
		STAND		: VANGLECHANGE
		STAND		: FAKEPLAYERACTIVE
		START_JUMP	: JUMP
		STAND_2READY : USE
		STAND_2READY : ATTACKRIGHT
		STAND_2READY : ATTACK_ALTERNATE

		STAND_IDLE : ANIMDONE_LEGS
	}
}

state STAND_IDLE
{
	legs
	{
		idle_base_01 : default
	}

	states
	{
		STAND		: FORWARD 
		STAND		: BACKWARD 
		STAND		: STRAFE_LEFT 
		STAND		: STRAFE_RIGHT
		STAND		: VANGLECHANGE
		STAND		: FAKEPLAYERACTIVE
		START_JUMP	: JUMP
		STAND_2READY : USE
		STAND_2READY : ATTACKRIGHT
		STAND_2READY : ATTACK_ALTERNATE

		STAND_IDLE_PLAY : !CAN_FALL STATETIME_LEGS "15" ANIMDONE_LEGS
	}
}

state STAND_IDLE_PLAY
{
	legs
	{
		knife_idle		: IS_WEAPON_ACTIVE "righthand" "Knife"
		mallet_idle		: IS_WEAPON_ACTIVE "righthand" "mallet"
		cards_idle		: IS_WEAPON_ACTIVE "righthand" "cards"
		jbomb_idle		: IS_WEAPON_ACTIVE "righthand" "jackbomb"
		idle_base_01_play	: default
	}

	exitcommands
	{
		removeattachedmodel tag_shoulder02
		removeattachedmodel tag_01
		removeattachedmodel tag_02
		removeattachedmodel tag_03
		removeattachedmodel tag_ball_linked
		hideweapon 0
	}

	states
	{
		STAND		: VANGLECHANGE
		STAND		: FORWARD 
		STAND		: BACKWARD 
		STAND		: STRAFE_LEFT 
		STAND		: STRAFE_RIGHT
		STAND		: FAKEPLAYERACTIVE
		START_JUMP	 : JUMP
		STAND_2READY : USE
		STAND_2READY : ATTACKRIGHT
		STAND_2READY : ATTACK_ALTERNATE

		STAND_IDLE : ANIMDONE_LEGS
	}
}

state STAND_2READY
{
	legs
	{
		stand01_2_ready : default
	}

	states
	{
		STAND : ANIMDONE_LEGS
	}
}

state START_JUMP
{
	legs
	{
		//jump_start : default
	}

	states
	{
		JUMP_TAKEOFF : default
	}
}

state JUMP_TAKEOFF
{
	legs
	{
		jump_small_takeoff : default
	}

	states
	{
		JUMP_FALL : ANIMDONE_LEGS
	}
}

state JUMP_FALL
{
	legs
	{
		jump_falling : default
	}

	states
	{
		SLIDING	: ENV_SLIDING
		THERMAL	: ENV_THERMAL
		SWIM_IDLE	: IN_WATER "1"
		JUMP_LAND	: ONGROUND
	}
}

state JUMP_LAND
{
	legs
	{
		jump_small_land : default
	}

	states
	{
		STAND : ANIMDONE_LEGS
	}
}

state RUN_FORWARD
{
	legs
	{
		run_smallwep : ANY_WEAPON_ACTIVE
		run_nowep : default
	}

	states
	{
		SLIDING		: ENV_SLIDING
		THERMAL		: ENV_THERMAL
		RUN_JUMP_FALL	: FALLING !ALTITUDE "31"

		RUN_JUMP		: ONGROUND +JUMP
		STAND			: !FORWARD !STRAFE_LEFT !STRAFE_RIGHT
		STAND			: +HAS_WEAPON
		STAND			: -HAS_WEAPON
		WALK_FORWARD	: !RUN
	}
}

state RUN_BACKWARD
{
	legs
	{
		run_back_smallwep : ANY_WEAPON_ACTIVE
		run_back_nowep : default
	}

	states
	{
		SLIDING		: ENV_SLIDING
		THERMAL		: ENV_THERMAL
		RUN_JUMP_FALL	: FALLING !ALTITUDE "31"

		RUN_JUMP		: ONGROUND +JUMP
		STAND			: !BACKWARD !STRAFE_LEFT !STRAFE_RIGHT
		WALK_BACKWARD	: !RUN
	}
}

state RUN_JUMP
{
	legs
	{
		run_jump : default
	}

	states
	{
		RUN_JUMP_FALL : !ONGROUND
	}
}

state RUN_JUMP_FALL
{
	legs
	{
		jump_falling : default
	}

	states
	{
		SLIDING	: ENV_SLIDING
		THERMAL	: ENV_THERMAL
		SWIM_IDLE	: IN_WATER "1"
		RUN_FORWARD	: ONGROUND FORWARD RUN
		JUMP_LAND	: ONGROUND
	}
}

state WALK_FORWARD
{
	legs
	{
		walk_smallwep : ANY_WEAPON_ACTIVE
		walk_nowep : default
	}

	states
	{
		SLIDING		: ENV_SLIDING
		THERMAL		: ENV_THERMAL
		RUN_JUMP_FALL	: FALLING !ALTITUDE "31"

		START_JUMP	: JUMP ONGROUND
		STAND 	: CAN_FALL ONGROUND
		STAND 	: !FORWARD !STRAFE_LEFT !STRAFE_RIGHT
		STAND		: +HAS_WEAPON
		STAND		: -HAS_WEAPON
		RUN_FORWARD	: RUN

		WALK_FORWARD_SPECIAL	: STATETIME_LEGS "5" ANIMDONE_LEGS CHANCE "0.333"
	}
}

state WALK_FORWARD_SPECIAL
{
	legs
	{
		walk_nowep_ : default
	}

	states
	{
		SLIDING		: ENV_SLIDING
		THERMAL		: ENV_THERMAL
		RUN_JUMP_FALL	: FALLING !ALTITUDE "31"

		START_JUMP	: +JUMP ONGROUND
		STAND 	: CAN_FALL ONGROUND
		STAND 	: !FORWARD !STRAFE_LEFT !STRAFE_RIGHT
		STAND		: +HAS_WEAPON
		STAND		: -HAS_WEAPON
		RUN_FORWARD	: RUN

		WALK_FORWARD	: ANIMDONE_LEGS STATETIME_LEGS "2" CHANCE "0.5"
	}
}

state WALK_BACKWARD
{
	legs
	{
		walk_back_smallwep : default
	}

	states
	{
		SLIDING		: ENV_SLIDING
		THERMAL		: ENV_THERMAL
		RUN_JUMP_FALL	: FALLING !ALTITUDE "31"

		START_JUMP		: +JUMP ONGROUND
		STAND 		: !BACKWARD !STRAFE_LEFT !STRAFE_RIGHT
		STAND			: +NEW_WEAPON
		RUN_BACKWARD	: RUN
	}
}

state SWIM_IDLE
{
	legs
	{
		swim_tred_wep : ANY_WEAPON_ACTIVE
		swim_tred : default
	}

	states
	{
		STAND			: ONGROUND !IN_WATER "1"
		RUN_JUMP_FALL	: !ONGROUND !IN_WATER "0"
		SWIM_RESET		: +HAS_WEAPON
		SWIM_RESET		: -HAS_WEAPON
		SWIM_FORWARD	: SWIMS_IN_WATER FORWARD
		SWIM_RESET		: -PAIN
	}
}

state SWIM_RESET
{
	states
	{
		SWIM_IDLE : default
	}
}

state SWIM_FORWARD
{
	legs
	{
		swim_forward_frog : default
	}

	states
	{
		STAND			: ONGROUND !IN_WATER "1"
		RUN_JUMP_FALL	: !ONGROUND !IN_WATER "0"
		SWIM_IDLE		: !FORWARD
	}
}

state SLIDING
{
	legs
	{
		slide : default
	}

	states
	{
		STAND		: !ENV_SLIDING
		SLIDE_JUMP	: JUMP
	}
}

state SLIDE_JUMP
{
	legs
	{
		jump_small_takeoff : default
	}

	states
	{
		RUN_JUMP_FALL : ANIMDONE_LEGS
	}
}

state THERMAL
{
	legs
	{
		float : default
	}

	states
	{
		STAND		: ONGROUND !ENV_THERMAL
	}
}
