state STAND
{
   camera behind
   movetype legs

	torso
	{
		burn	: ON_FIRE
	}

	states
	{
		FROZEN		: FROZEN
		HELD			: IS_GRABBED
		CHESS_PUZZLE	: LEGS "CHESS_PUZZLE"

		KILLED		: KILLED
		PAIN			: PAIN

		GRASSHOPPER		: TEA

		RAISE_WEAPON	: NEW_WEAPON
		PUTAWAY_RIGHT	: PUTAWAYRIGHT

		OUT_OF_MANA		: ATTACKRIGHT !IS_CURRENT_WEAPON_MANA_OK "primary"
		OUT_OF_MANA		: ATTACK_ALTERNATE !IS_CURRENT_WEAPON_MANA_OK "alternate"

		ATTACK_START		: ATTACKRIGHT
		ATTACK_START_ALTERNATE  : ATTACK_ALTERNATE

		CLIMB_32		: ONGROUND !IN_WATER "2" +FORWARD !USE LEDGE_HEIGHT "31" "36"
		CLIMB_48		: ONGROUND !IN_WATER "2" +FORWARD !USE LEDGE_HEIGHT "40" "52"
		CLIMB_64		: ONGROUND !IN_WATER "2" +FORWARD !USE LEDGE_HEIGHT "60" "68"

		ROPE_HANG         : !ONGROUND TOUCHED_ROPE
		ROPE_USE		: ONGROUND USE TOUCHED_ROPE

	      HANG              : ONGROUND !IN_WATER "2" +FORWARD USE !CROUCH !BACKWARD !STRAFE_RIGHT !STRAFE_LEFT CAN_GRAB_LEDGE CAN_HANG
	      HANG              : !ONGROUND !IN_WATER "2" CAN_GRAB_LEDGE CAN_HANG

		USE			: USE AT_DOOR		
		USE_USEOBJECT	: USE AT_USEOBJECT

		IDLE_CAMERA		: LEGS "STAND_IDLE_PLAY" !VANGLECHANGE

		SWIM 			: IN_WATER "2"
		STAND_RESET		: -ON_FIRE
	}
}

state STAND_RESET
{
	states
	{
		STAND	: default
	}
}

state OUT_OF_MANA
{
   camera behind
   movetype legs

	torso
	{
		switch_to_knife : default
	}

	states
	{
		RAISE_WEAPON	: NEW_WEAPON
		PUTAWAY_RIGHT	: PUTAWAYRIGHT
		STAND			: ANIMDONE_TORSO
	}
}

state CHESS_PUZZLE
{
camera behind
movetype legs

	states
	{
		STAND	: !LEGS "CHESS_PUZZLE" !LEGS "CHESS_MOVE"
	}
}

state IDLE_CAMERA
{
//camera bulletcam 80 -50 20 1 linear radial target 0 0 5
camera frontright

	states
	{
		RAISE_WEAPON	: NEW_WEAPON
		PUTAWAY_RIGHT	: PUTAWAYRIGHT
		GRASSHOPPER		: TEA

		ATTACK_START		: ATTACKRIGHT IS_CURRENT_WEAPON_READY_TO_FIRE "primary"
		ATTACK_START_ALTERNATE  : ATTACK_ALTERNATE IS_CURRENT_WEAPON_READY_TO_FIRE "alternate"

		STAND	: !LEGS "STAND_IDLE_PLAY" !LEGS "STAND_IDLE"
	}
}

state SWIM
{
   //camera bulletcam -80 0 20 0.9 damped radial viewtarget 0 0 20
   camera swim_behind
   movetype legs

	states
	{
		FROZEN		: FROZEN
		HELD			: IS_GRABBED

		KILLED		: KILLED
		PAIN			: PAIN

		RAISE_WEAPON	: NEW_WEAPON
		PUTAWAY_RIGHT	: PUTAWAYRIGHT

		ATTACK_START		: ATTACKRIGHT IS_CURRENT_WEAPON_READY_TO_FIRE "primary"
		ATTACK_START_ALTERNATE  : ATTACK_ALTERNATE IS_CURRENT_WEAPON_READY_TO_FIRE "alternate"
		USE			: USE AT_DOOR		
		USE_USEOBJECT	: USE AT_USEOBJECT

		STAND : !IN_WATER "2"
	}
}

state ATTACK_START
{
	entrycommands
	{
		setlastfiredtime
	}
	states
	{
		GRASSHOPPER		: TEA
		ATTACK_RIGHT	: default
	}
}

state ATTACK_START_ALTERNATE
{
	entrycommands
	{
		setlastfiredtime
	}
	states
	{
		GRASSHOPPER		: TEA
		ATTACK_ALTERNATE	:	default
	}
}

state ATTACK_RIGHT
{
	movetype legs

	torso
	{
		knife_att_1_prim : IS_WEAPON_READY_TO_FIRE "Knife"
		mallet_att_1_prim : IS_WEAPON_READY_TO_FIRE "mallet"
		cards_att_prim : IS_WEAPON_READY_TO_FIRE "cards"
		jbomb_att_2_prim : IS_WEAPON_READY_TO_FIRE "jackbomb"
		weapon_not_ready : default
	}

	states
	{
		GRASSHOPPER	 : TEA
		FROZEN	 : FROZEN
		HELD		 : IS_GRABBED
		KILLED 	 : KILLED
		PAIN		 : ANIMDONE_TORSO PAIN
		STAND	 	 : ANIMDONE_TORSO !IS_CURRENT_WEAPON_READY_TO_FIRE "primary"
		STAND 	 : ANIMDONE_TORSO
	}
}

state ATTACK_ALTERNATE
{
   movetype legs
	torso
	{
		knife_att_1_alt : IS_WEAPON_READY_TO_FIRE "Knife"
		mallet_att_3_alt : IS_WEAPON_READY_TO_FIRE "mallet"
		cards_att_1_alt : IS_WEAPON_READY_TO_FIRE "cards"
		jbomb_att_2_alt : IS_WEAPON_READY_TO_FIRE "jackbomb"
		weapon_not_ready : default
	}

	states
	{
		GRASSHOPPER		: TEA
		FROZEN		: FROZEN
		HELD			: IS_GRABBED
		KILLED 		: KILLED
		PAIN			: ANIMDONE_TORSO PAIN
		STAND			: ANIMDONE_TORSO
	}
}

state RAISE_WEAPON
{
   movetype legs

	entrycommands
	{
		setlastfiredtime
	}

	torso
	{
		changeweapon : default
	}

	states
	{
		KILLED : KILLED
		STAND : ANIMDONE_TORSO !NEW_WEAPON
	}
}

state PUTAWAY_RIGHT
{
   movetype legs
	torso
	{
		putawayweapon : default
	}

	states
	{
		KILLED : KILLED
		STAND : ANIMDONE_TORSO !PUTAWAYRIGHT
	}
}

state PAIN
{
	movetype legs

	torso
	{
	}

	states
	{
		KILLED 	: KILLED
		STAND		: ON_FIRE
		SMALL_PAIN : IN_WATER
		BIG_PAIN	: PAIN_THRESHOLD "23"
		SMALL_PAIN 	: default
	}

	exitcommands
	{
		nextpaintime 2.5
	}
}

state SMALL_PAIN
{
	movetype legs

	torso
	{
		pain_water : IN_WATER
		pain_front : PAIN_DIRECTION "Rear"
		pain_front : PAIN_DIRECTION "Front"
		pain_right : PAIN_DIRECTION "Left"
		pain_left : PAIN_DIRECTION "Right"
		pain_front : default
	}

	states
	{
		KILLED : KILLED
		STAND : ANIMDONE_TORSO
	}
}

state BIG_PAIN
{
	movetype anim

	legs
	{
		pain_knockdown : PAIN_DIRECTION "Front" CHANCE "0.5"
		pain_strong_right : PAIN_DIRECTION "Left"
		pain_strong_left : PAIN_DIRECTION "Right"
		pain_front : default
	}

	states
	{
		KILLED : KILLED
		STAND  : ANIMDONE_LEGS
	}
}

/////////////////////////////////////////////
// STATE for when Alice is held by an enemy
/////////////////////////////////////////////

state HELD
{
//movetype absolute
movetype legs
camera topdown

	legs
	{
		held : default
	}

	states
	{
		STAND : !IS_GRABBED
	}
}

// --------------------------------

state KILLED
{
	movetype anim

	states
	{
		DEATH_WATER : IN_WATER "2" !ON_FIRE
		DEATH_GIB	: PAIN_TYPE "gib" CHANCE "0.2"
		DEATH		: default
	}
}

state DEATH_WATER
{
camera bulletcam -70 0 20 0.4 damped radial viewtarget 0 0 20
movetype anim

	legs
	{
		death_drown : default
	}

	states
	{
		KILLED_DONE : ANIMDONE_LEGS
	}

	exitcommands
	{
		dead
	}
}

state DEATH_GIB
{
movetype anim

	legs
	{
		death_gib : default
	}

	states
	{
		KILLED_DONE : ANIMDONE_LEGS
	}

	exitcommands
	{
		dead
	}
}

state DEATH
{
movetype anim

	legs
	{
		death_hideous : PAIN_THRESHOLD "40" CHANCE "0.7"
		death_forward : PAIN_DIRECTION "Rear" CHANCE "0.9"
		death_hard : PAIN_DIRECTION "Front" PAIN_THRESHOLD "23" CHANCE "0.8"
		death_knockback : PAIN_DIRECTION "Front" CHANCE "0.8"
		death_faint : CHANCE "0.6"
		death_hard : CHANCE "0.8"
		death_hideous : default
	}

	states
	{
		KILLED_DONE : ANIMDONE_LEGS
	}

	exitcommands
	{
		dead
	}
}

state KILLED_DONE
{
	movetype anim
}

state KILLED_FALLING
{
	movetype legs

	camera topdown

	legs
	{
		death_falling : default
	}
}

////////////////////////////////////////////////////////////////////
//    HANGING     
////////////////////////////////////////////////////////////////////

state PULL_UP
   {
   movetype hanging

   camera topdown

   legs
      {
      ledge_pullup : default
      }

   states
      {
		KILLED 	: KILLED
		STAND       : ANIMDONE_LEGS
      }
   }

state HANG
   {
   movetype hanging

   camera topdown

   legs
      {
      //hang_grab_wall    : HANG_ATWALL
      hang_idle	         : default
      }

   states
      {
	KILLED 	: KILLED
	HANG_PAIN	: PAIN CHANCE "0.5"
      HANG_IDLE   : default //ANIMDONE_LEGS
      }
   }

state HANG_PAIN
{
movetype hanging
camera topdown

	legs
	{
		hang_pain : default
	}

	states
	{
		HANG_IDLE	: ANIMDONE_LEGS
	}
}

state HANG_IDLE
   {
   movetype hanging

   camera topdown

   legs
      {
      hang_idle : default
      }

   states
      {
		KILLED 	: KILLED
		HANG_PAIN	: PAIN CHANCE "0.5"
		HANG_MOVE_LEFT    : STRAFE_LEFT CAN_HANG_LEFT
		HANG_MOVE_RIGHT   : STRAFE_RIGHT CAN_HANG_RIGHT
		PULL_UP           : +FORWARD CAN_PULLUP
		HANG_LETGO        : BACKWARD
		HANG_LETGO        : CROUCH
      }
   }

state HANG_LETGO
   {
   movetype legs

   legs
      {
      hang_idle : default
      }

   states
      {
	KILLED 	: KILLED
      STAND          : ONGROUND
      STAND          : ANIMDONE_LEGS
      }
   }

state HANG_MOVE_LEFT
   {
   movetype hanging

   camera topdown

   legs
      {
      shimmy_left : default
      }

   states
      {
		KILLED 	: KILLED
		HANG_PAIN	: PAIN CHANCE "0.5"
		HANG              : ANIMDONE_LEGS !STRAFE_LEFT
		HANG              : ANIMDONE_LEGS !CAN_HANG_LEFT
      }
   }

state HANG_MOVE_RIGHT
   {
   movetype hanging

   camera topdown

   legs
      {
      shimmy_right : default
      }

   states
      {
		KILLED 	: KILLED
		HANG_PAIN	: PAIN CHANCE "0.5"
		HANG        : ANIMDONE_LEGS !STRAFE_RIGHT
		HANG        : ANIMDONE_LEGS !CAN_HANG_RIGHT
      }
   }

////////////////////////////////////////////////////////////////
// Rope
////////////////////////////////////////////////////////////////

state ROPE_USE
{
   movetype rope_grab

   legs
   {
	rope_grab	: default
   }

   states
   {
	ROPE_RELEASE	: KILLED
	ROPE_RELEASE	: PAIN CHANCE "0.1"
      ROPE_RELEASE      : +JUMP
      ROPE_RELEASE      : !ONROPE
      ROPE_HANG         : ANIMDONE_LEGS
   }
}

state ROPE_GRAB
{
   movetype rope_grab

   legs
   {
	rope_hang	: default
   }

   states
   {
	ROPE_RELEASE	: KILLED
	ROPE_RELEASE	: PAIN CHANCE "0.1"
      ROPE_RELEASE      : +JUMP
      ROPE_RELEASE      : !ONROPE
      ROPE_HANG         : ANIMDONE_LEGS
   }
}

state ROPE_HANG
{
   movetype rope_grab

   legs
   {
	rope_hang         : default
   }

   states
   {
	ROPE_RELEASE	: KILLED
	ROPE_RELEASE	: PAIN CHANCE "0.1"
      ROPE_RELEASE      : +JUMP
      ROPE_RELEASE      : !ONROPE
      ROPE_CLIMB_UP_RIGHT  : USE
      ROPE_CLIMB_DOWN_LEFT  : CROUCH
	ROPE_SWING_FORWARD : FORWARD
	ROPE_SWING_BACKWARD : BACKWARD
      ROPE_HANG         : ANIMDONE_LEGS
   }
}

state ROPE_SWING_FORWARD
{
movetype rope_grab

	legs
	{
		rope_swing_forward : default
	}

	states
	{
		ROPE_RELEASE	: KILLED
		ROPE_RELEASE	: PAIN CHANCE "0.1"
	      ROPE_RELEASE      : +JUMP
	      ROPE_RELEASE      : !ONROPE
	      ROPE_CLIMB_UP_RIGHT  : USE
	      ROPE_CLIMB_DOWN_LEFT  : CROUCH
	      ROPE_HANG         : ANIMDONE_LEGS
	}
}

state ROPE_SWING_BACKWARD
{
movetype rope_grab

	legs
	{
		rope_swing_backward : default
	}

	states
	{
		ROPE_RELEASE	: KILLED
		ROPE_RELEASE	: PAIN CHANCE "0.1"
	      ROPE_RELEASE      : +JUMP
	      ROPE_RELEASE      : !ONROPE
	      ROPE_CLIMB_UP_RIGHT  : USE
	      ROPE_CLIMB_DOWN_LEFT  : CROUCH
	      ROPE_HANG         : ANIMDONE_LEGS
	}
}

state ROPE_CLIMB_UP_RIGHT
{
   movetype rope_move

   legs
   {
      rope_climb_up_right     : default
   }

   states
   {
	ROPE_RELEASE	   : KILLED
	ROPE_RELEASE	   : PAIN CHANCE "0.1"
      ROPE_RELEASE         : +JUMP
      ROPE_RELEASE         : !ONROPE
      ROPE_CLIMB_UP_LEFT   : ANIMDONE_LEGS
   }
}

state ROPE_CLIMB_UP_LEFT
{
   movetype rope_move

   legs
   {
      rope_climb_up_left     : default
   }

   states
   {
	ROPE_RELEASE	   : KILLED
	ROPE_RELEASE	   : PAIN CHANCE "0.1"
      ROPE_RELEASE         : +JUMP
      ROPE_RELEASE         : !ONROPE
      ROPE_HANG            : ANIMDONE_LEGS
   }
}

state ROPE_CLIMB_DOWN_LEFT
{
   movetype rope_move
   
   legs
   {
      rope_climb_down_left   : default
   }

   states
   {
	ROPE_RELEASE	: KILLED
	ROPE_RELEASE	: PAIN CHANCE "0.1"
      ROPE_RELEASE      : +JUMP
      ROPE_RELEASE      : !ONROPE
      ROPE_CLIMB_DOWN_RIGHT  : ANIMDONE_LEGS
   }
}

state ROPE_CLIMB_DOWN_RIGHT
{
   movetype rope_move
   
   legs
   {
      rope_climb_down_right   : default
   }

   states
   {
	ROPE_RELEASE	: KILLED
	ROPE_RELEASE	: PAIN CHANCE "0.1"
      ROPE_RELEASE      : +JUMP
      ROPE_RELEASE      : !ONROPE
      ROPE_HANG         : ANIMDONE_LEGS
   }
}

state ROPE_RELEASE
{
   movetype rope_release

   legs
   {
	jump_falling : default
   }

   states
   {
	KILLED	: KILLED
      STAND		: !ONROPE ANIMDONE_LEGS
   }
}

////////////////////////////////////////////////////////////////
//
// Step up
//
////////////////////////////////////////////////////////////////

state CLIMB_32
{
   movetype stepup

   legs
   {
      climb_32 : default
   }

   states
   {
	KILLED 	: KILLED
      STAND : ANIMDONE_LEGS
   }
}

state CLIMB_48
{
   movetype stepup

   legs
   {
      climb_48 : default
   }

   states
   {
	KILLED 	: KILLED
      STAND : ANIMDONE_LEGS
   }
}

state CLIMB_64
{
   movetype stepup

   legs
   {
      climb_64 : default
   }

   states
   {
	KILLED 	: KILLED
      STAND : ANIMDONE_LEGS
   }
}

//////////
//
// FROZEN ALICE
//
//////////
state FROZEN
{
   movetype absolute
   camera bulletcam 0 0 0 1 damped animate waterice

   states
   {
	STAND : !FROZEN
   }
}

/////
//
// GRASSHOPPER TEA
//
/////
state GRASSHOPPER
{
   movetype absolute
   camera bulletcam 30 -40 10 0.1 damped radial target 0 0 10

   legs
   {
	grasshoppertea : default
   }

   states
   {
	STAND : ANIMDONE_LEGS
   }
}

state USE
{
	torso
	{
		use : default
	}

	states
	{
		STAND : ANIMDONE_TORSO
	}
}

////////////////////////////////////////////////////////////////
//
// Standing at a UseObject
//
////////////////////////////////////////////////////////////////

state USE_USEOBJECT
{
   movetype useobject

   legs
   {
      //
      // there is no anim, since this state will be exited as soon as
      // we figure out which state to go into
      //
      none        : default
   }

   states
   {
      // we don't really expect to go back to stand, but this is here so we don't
      // get stuck in this state
      STAND       : default
   }
}

state USELEVER
{
movetype absolute
camera side_left

	legs
	{
		use_lever : default
	}

	entrycommands
	{
		hideweapon 1
		startuseobject
	}

	exitcommands
	{
		hideweapon 0
		finishuseobject
	}

	states
	{
		STAND : ANIMDONE_LEGS
	}
}

state USELEVER_BACKWARDS
{
movetype absolute

	legs
	{
		use_lever : default
	}

	entrycommands
	{
		hideweapon 1
		startuseobject
	}

	exitcommands
	{
		hideweapon 0
		finishuseobject
	}

	states
	{
		STAND : ANIMDONE_LEGS
	}
}
